package gregapi.old.metatileentity.implementations;

import static gregapi.data.CS.RA;
import gregapi.data.IL;
import gregapi.data.OP;
import gregapi.data.TD;
import gregapi.old.interfaces.metatileentity.IMetaTileEntity;
import gregapi.old.interfaces.tileentity.IGregTechTileEntity;
import gregapi.old.metatileentity.MetaPipeEntity;
import gregapi.oredict.OreDictManager;
import gregapi.oredict.OreDictMaterial;
import gregapi.recipes.GT_ModHandler;
import gregapi.recipes.GT_ModHandler.RecipeBits;
import gregapi.util.OM;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;

public class GT_MetaPipeEntity_Frame extends MetaPipeEntity {
	public final OreDictMaterial mMaterial;
	
	public GT_MetaPipeEntity_Frame(int aID, String aName, String aNameRegional, OreDictMaterial aMaterial) {
		super(aID, aName, aNameRegional, 0);
		mMaterial = aMaterial;
		
		OreDictManager.INSTANCE.registerOre(OP.frameGt, aMaterial, getStackForm(1));
		GT_ModHandler.addCraftingRecipe(getStackForm(2), RecipeBits.NOT_REMOVABLE | GT_ModHandler.RecipeBits.BUFFERED, new Object[] {"SSS", "SwS", "SSS", 'S', OP.stick.get(mMaterial)});
		RA.addAssemblerRecipe(OM.get(OP.stick, aMaterial, 4), IL.Circuit_Integrated.getWithDamage(0, 4), getStackForm(1), 64, 8);
	}
	
	public GT_MetaPipeEntity_Frame(String aName, OreDictMaterial aMaterial) {
		super(aName, 0);
		mMaterial = aMaterial;
	}
	
	@Override
	public byte getTileEntityBaseType() {
		return mMaterial==null?4:(byte)((mMaterial.contains(TD.Properties.WOOD) ? 12 : 4) + Math.max(0, Math.min(3, mMaterial.mToolQuality)));
	}
	
	@Override
	public IMetaTileEntity newMetaEntity(IGregTechTileEntity aTileEntity) {
		return new GT_MetaPipeEntity_Frame(mName, mMaterial);
	}
	
//	@Override
//	public ITexture[] getTexture(IGregTechTileEntity aBaseMetaTileEntity, byte aSide, byte aConnections, byte aColorIndex, boolean aConnected, boolean aRedstone) {
//		return new ITexture[]	{new BlockTextureDefault(mMaterial.mIconSet.mTextures[OP.frameGt.mTextureIndex], Dyes.getModulation(aColorIndex, mMaterial.mRGBa))};
//	}
	
	@Override public String[] getDescription() {return new String[] {"Just something you can put a Cover or CFoam on."};}
	
	@Override public final boolean isSimpleMachine()				{return true;}
	@Override public final boolean isFacingValid(byte aFacing)		{return false;}
	@Override public final boolean isValidSlot(int aIndex)			{return false;}
    @Override public final boolean renderInside(byte aSide)			{return true;}
	@Override public final float getThickNess() {return 1.0F;}
	@Override public final void saveNBTData(NBTTagCompound aNBT) {/*Do nothing*/}
	@Override public final void loadNBTData(NBTTagCompound aNBT) {/*Do nothing*/}
	@Override public final boolean allowPutStack(IGregTechTileEntity aBaseMetaTileEntity, int aIndex, byte aSide, ItemStack aStack) {return false;}
	@Override public final boolean allowPullStack(IGregTechTileEntity aBaseMetaTileEntity, int aIndex, byte aSide, ItemStack aStack) {return false;}
}