package gregapi.old.metatileentity.implementations;

import static gregapi.data.CS.V;
import static gregapi.data.CS.W;
import gregapi.data.IL;
import gregapi.data.MT;
import gregapi.data.OP;
import gregapi.old.Textures;
import gregapi.old.Tier;
import gregapi.old.gui.GT_Container_BasicMachine;
import gregapi.old.gui.GT_GUIContainer_BasicMachine;
import gregapi.old.interfaces.metatileentity.IMetaTileEntity;
import gregapi.old.interfaces.tileentity.IGregTechTileEntity;
import gregapi.recipes.GT_ModHandler;
import gregapi.recipes.GT_ModHandler.RecipeBits;
import gregapi.recipes.Recipe.RecipeMap;
import gregapi.render.BlockTextureDefault;
import gregapi.render.ITexture;
import gregapi.util.UT;

import java.util.Random;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.FluidStack;

/**
 * NEVER INCLUDE THIS FILE IN YOUR MOD!!!
 * 
 * This is the main construct for my Basic Machines such as the Automatic Extractor
 * Extend this class to make a simple Machine
 */
public class GT_MetaTileEntity_BasicMachine_GT_Recipe extends GT_MetaTileEntity_BasicMachine {
	public static enum X {PUMP, WIRE, WIRE4, HULL, PIPE, GLASS, PLATE, MOTOR, ROTOR, SENSOR, PISTON, CIRCUIT, EMITTER, CONVEYOR, ROBOT_ARM, COIL_HEATING, COIL_ELECTRIC, STICK_MAGNETIC, STICK_DISTILLATION, BETTER_CIRCUIT, FIELD_GENERATOR, COIL_HEATING_DOUBLE, STICK_ELECTROMAGNETIC;}
	
	private final RecipeMap mRecipes;
	private final int mTankCapacity, mSpecialEffect;
	private final String mSound;
	private final boolean mSharedTank, mRequiresFluidForFiltering;
	private final byte mGUIParameterA, mGUIParameterB;
	
	public GT_MetaTileEntity_BasicMachine_GT_Recipe(int aID, String aName, String aNameRegional, int aTier, String aDescription, RecipeMap aRecipes, int aInputSlots, int aOutputSlots, int aTankCapacity, int aGUIParameterA, int aGUIParameterB, String aGUIName, String aSound, boolean aSharedTank, boolean aRequiresFluidForFiltering, int aSpecialEffect, String aOverlays, Object[] aRecipe) {
		super(aID, aName, aNameRegional, aTier, aRecipes.mAmperage, aDescription, aInputSlots, aOutputSlots, aGUIName, aRecipes.mNEIName, new ITexture[] {new BlockTextureDefault(new Textures.BlockIcons.CustomIcon("basicmachines/" + aOverlays.toLowerCase() + "/OVERLAY_SIDE_ACTIVE")), new BlockTextureDefault(new Textures.BlockIcons.CustomIcon("basicmachines/" + aOverlays.toLowerCase() + "/OVERLAY_SIDE")), new BlockTextureDefault(new Textures.BlockIcons.CustomIcon("basicmachines/" + aOverlays.toLowerCase() + "/OVERLAY_FRONT_ACTIVE")), new BlockTextureDefault(new Textures.BlockIcons.CustomIcon("basicmachines/" + aOverlays.toLowerCase() + "/OVERLAY_FRONT")), new BlockTextureDefault(new Textures.BlockIcons.CustomIcon("basicmachines/" + aOverlays.toLowerCase() + "/OVERLAY_TOP_ACTIVE")), new BlockTextureDefault(new Textures.BlockIcons.CustomIcon("basicmachines/" + aOverlays.toLowerCase() + "/OVERLAY_TOP")), new BlockTextureDefault(new Textures.BlockIcons.CustomIcon("basicmachines/" + aOverlays.toLowerCase() + "/OVERLAY_BOTTOM_ACTIVE")), new BlockTextureDefault(new Textures.BlockIcons.CustomIcon("basicmachines/" + aOverlays.toLowerCase() + "/OVERLAY_BOTTOM"))});
		mSharedTank = aSharedTank;
		mTankCapacity = aTankCapacity;
		mSpecialEffect = aSpecialEffect;
		mRequiresFluidForFiltering = aRequiresFluidForFiltering;
		mRecipes = aRecipes;
		mSound = aSound;
		mGUIParameterA = (byte)aGUIParameterA;
		mGUIParameterB = (byte)aGUIParameterB;
		
		if (aRecipe != null) {
			for (int i = 3; i < aRecipe.length; i++) {
				if (aRecipe[i] == X.CIRCUIT)			{aRecipe[i] = Tier.ELECTRIC[mTier].mManagingObject;					continue;}
				if (aRecipe[i] == X.BETTER_CIRCUIT)		{aRecipe[i] = Tier.ELECTRIC[mTier].mBetterManagingObject;			continue;}
				if (aRecipe[i] == X.HULL)				{aRecipe[i] = Tier.ELECTRIC[mTier].mHullObject;						continue;}
				if (aRecipe[i] == X.WIRE)				{aRecipe[i] = Tier.ELECTRIC[mTier].mConductingObject;				continue;}
				if (aRecipe[i] == X.WIRE4)				{aRecipe[i] = Tier.ELECTRIC[mTier].mLargerConductingObject;			continue;}
				
				if (aRecipe[i] == X.GLASS) {switch(mTier) {
				default:			aRecipe[i] = new ItemStack(Blocks.glass, 1, W); break;
				}continue;}
				
				if (aRecipe[i] == X.PLATE) {switch(mTier) {
				case  0: case  1:	aRecipe[i] = OP.plate.get(MT.TECH.AnyIronSteel); break;
				case  2:			aRecipe[i] = OP.plate.get(MT.Aluminium); break;
				case  3:			aRecipe[i] = OP.plate.get(MT.StainlessSteel); break;
				case  4:			aRecipe[i] = OP.plate.get(MT.Titanium); break;
				default:			aRecipe[i] = OP.plate.get(MT.TungstenSteel); break;
				}continue;}
				
				if (aRecipe[i] == X.PIPE) {switch(mTier) {
				case  0: case  1:	aRecipe[i] = OP.pipeMedium.get(MT.Bronze); break;
				case  2:			aRecipe[i] = OP.pipeMedium.get(MT.TECH.AnyIronSteel); break;
				case  3:			aRecipe[i] = OP.pipeMedium.get(MT.StainlessSteel); break;
				case  4:			aRecipe[i] = OP.pipeMedium.get(MT.Titanium); break;
				default:			aRecipe[i] = OP.pipeMedium.get(MT.TungstenSteel); break;
				}continue;}
				
				if (aRecipe[i] == X.COIL_HEATING) {switch(mTier) {
				case  0: case  1:	aRecipe[i] = OP.wireGt02.get(MT.TECH.AnyCopper); break;
				case  2:			aRecipe[i] = OP.wireGt02.get(MT.Cupronickel); break;
				case  3:			aRecipe[i] = OP.wireGt02.get(MT.Kanthal); break;
				case  4:			aRecipe[i] = OP.wireGt02.get(MT.Nichrome); break;
				default:			aRecipe[i] = OP.wireGt08.get(MT.Nichrome); break;
				}continue;}
				
				if (aRecipe[i] == X.COIL_HEATING_DOUBLE) {switch(mTier) {
				case  0: case  1:	aRecipe[i] = OP.wireGt04.get(MT.TECH.AnyCopper); break;
				case  2:			aRecipe[i] = OP.wireGt04.get(MT.Cupronickel); break;
				case  3:			aRecipe[i] = OP.wireGt04.get(MT.Kanthal); break;
				case  4:			aRecipe[i] = OP.wireGt04.get(MT.Nichrome); break;
				default:			aRecipe[i] = OP.wireGt16.get(MT.Nichrome); break;
				}continue;}
				
				if (aRecipe[i] == X.STICK_DISTILLATION) {switch(mTier) {
				default:			aRecipe[i] = OP.stick.get(MT.Blaze); break;
				}continue;}
				
				if (aRecipe[i] == X.STICK_MAGNETIC) {switch(mTier) {
				case  0: case  1:	aRecipe[i] = OP.stick.get(MT.IronMagnetic); break;
				case  2: case  3:	aRecipe[i] = OP.stick.get(MT.SteelMagnetic); break;
				default:			aRecipe[i] = OP.stick.get(MT.NeodymiumMagnetic); break;
				}continue;}
				
				if (aRecipe[i] == X.STICK_ELECTROMAGNETIC) {switch(mTier) {
				case  0: case  1:	aRecipe[i] = OP.stick.get(MT.TECH.AnyIron); break;
				case  2: case  3:	aRecipe[i] = OP.stick.get(MT.TECH.AnyIronSteel); break;
				case  4:			aRecipe[i] = OP.stick.get(MT.Neodymium); break;
				default:			aRecipe[i] = OP.stick.get(MT.VanadiumGallium); break;
				}continue;}
				
				if (aRecipe[i] == X.COIL_ELECTRIC) {switch(mTier) {
				case  0:			aRecipe[i] = OP.wireGt01.get(MT.Tin); break;
				case  1:			aRecipe[i] = OP.wireGt02.get(MT.Tin); break;
				case  2:			aRecipe[i] = OP.wireGt02.get(MT.TECH.AnyCopper); break;
				case  3:			aRecipe[i] = OP.wireGt04.get(MT.TECH.AnyCopper); break;
				case  4:			aRecipe[i] = OP.wireGt08.get(MT.AnnealedCopper); break;
				default:			aRecipe[i] = OP.wireGt16.get(MT.AnnealedCopper); break;
				}continue;}
				
				if (aRecipe[i] == X.ROBOT_ARM) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = IL.Robot_Arm_LV; break;
				case  2:			aRecipe[i] = IL.Robot_Arm_MV; break;
				case  3:			aRecipe[i] = IL.Robot_Arm_HV; break;
				case  4:			aRecipe[i] = IL.Robot_Arm_EV; break;
				case  5:			aRecipe[i] = IL.Robot_Arm_IV; break;
				case  6:			aRecipe[i] = IL.Robot_Arm_LuV; break;
				case  7:			aRecipe[i] = IL.Robot_Arm_ZPM; break;
				default:			aRecipe[i] = IL.Robot_Arm_UV; break;
				}continue;}
				
				if (aRecipe[i] == X.PUMP) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = IL.Electric_Pump_LV; break;
				case  2:			aRecipe[i] = IL.Electric_Pump_MV; break;
				case  3:			aRecipe[i] = IL.Electric_Pump_HV; break;
				case  4:			aRecipe[i] = IL.Electric_Pump_EV; break;
				case  5:			aRecipe[i] = IL.Electric_Pump_IV; break;
				case  6:			aRecipe[i] = IL.Electric_Pump_LuV; break;
				case  7:			aRecipe[i] = IL.Electric_Pump_ZPM; break;
				default:			aRecipe[i] = IL.Electric_Pump_UV; break;
				}continue;}
				
				if (aRecipe[i] == X.ROTOR) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = OP.rotor.get(MT.Tin); break;
				case  2:			aRecipe[i] = OP.rotor.get(MT.Bronze); break;
				case  3:			aRecipe[i] = OP.rotor.get(MT.TECH.AnyIronSteel); break;
				case  4:			aRecipe[i] = OP.rotor.get(MT.StainlessSteel); break;
				case  5:			aRecipe[i] = OP.rotor.get(MT.TungstenSteel); break;
				case  6:			aRecipe[i] = OP.rotor.get(MT.TungstenSteel); break;
				case  7:			aRecipe[i] = OP.rotor.get(MT.TungstenSteel); break;
				default:			aRecipe[i] = OP.rotor.get(MT.TungstenSteel); break;
				}continue;}
				
				if (aRecipe[i] == X.MOTOR) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = IL.Electric_Motor_LV; break;
				case  2:			aRecipe[i] = IL.Electric_Motor_MV; break;
				case  3:			aRecipe[i] = IL.Electric_Motor_HV; break;
				case  4:			aRecipe[i] = IL.Electric_Motor_EV; break;
				case  5:			aRecipe[i] = IL.Electric_Motor_IV; break;
				case  6:			aRecipe[i] = IL.Electric_Motor_LuV; break;
				case  7:			aRecipe[i] = IL.Electric_Motor_ZPM; break;
				default:			aRecipe[i] = IL.Electric_Motor_UV; break;
				}continue;}
				
				if (aRecipe[i] == X.PISTON) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = IL.Electric_Piston_LV; break;
				case  2:			aRecipe[i] = IL.Electric_Piston_MV; break;
				case  3:			aRecipe[i] = IL.Electric_Piston_HV; break;
				case  4:			aRecipe[i] = IL.Electric_Piston_EV; break;
				case  5:			aRecipe[i] = IL.Electric_Piston_IV; break;
				case  6:			aRecipe[i] = IL.Electric_Piston_LuV; break;
				case  7:			aRecipe[i] = IL.Electric_Piston_ZPM; break;
				default:			aRecipe[i] = IL.Electric_Piston_UV; break;
				}continue;}
				
				if (aRecipe[i] == X.CONVEYOR) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = IL.Conveyor_Module_LV; break;
				case  2:			aRecipe[i] = IL.Conveyor_Module_MV; break;
				case  3:			aRecipe[i] = IL.Conveyor_Module_HV; break;
				case  4:			aRecipe[i] = IL.Conveyor_Module_EV; break;
				case  5:			aRecipe[i] = IL.Conveyor_Module_IV; break;
				case  6:			aRecipe[i] = IL.Conveyor_Module_LuV; break;
				case  7:			aRecipe[i] = IL.Conveyor_Module_ZPM; break;
				default:			aRecipe[i] = IL.Conveyor_Module_UV; break;
				}continue;}
				
				if (aRecipe[i] == X.EMITTER) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = IL.Emitter_LV; break;
				case  2:			aRecipe[i] = IL.Emitter_MV; break;
				case  3:			aRecipe[i] = IL.Emitter_HV; break;
				case  4:			aRecipe[i] = IL.Emitter_EV; break;
				case  5:			aRecipe[i] = IL.Emitter_IV; break;
				case  6:			aRecipe[i] = IL.Emitter_LuV; break;
				case  7:			aRecipe[i] = IL.Emitter_ZPM; break;
				default:			aRecipe[i] = IL.Emitter_UV; break;
				}continue;}
				
				if (aRecipe[i] == X.SENSOR) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = IL.Sensor_LV; break;
				case  2:			aRecipe[i] = IL.Sensor_MV; break;
				case  3:			aRecipe[i] = IL.Sensor_HV; break;
				case  4:			aRecipe[i] = IL.Sensor_EV; break;
				case  5:			aRecipe[i] = IL.Sensor_IV; break;
				case  6:			aRecipe[i] = IL.Sensor_LuV; break;
				case  7:			aRecipe[i] = IL.Sensor_ZPM; break;
				default:			aRecipe[i] = IL.Sensor_UV; break;
				}continue;}
				
				if (aRecipe[i] == X.FIELD_GENERATOR) {switch(mTier) {
				case  0: case 1:	aRecipe[i] = IL.Field_Generator_LV; break;
				case  2:			aRecipe[i] = IL.Field_Generator_MV; break;
				case  3:			aRecipe[i] = IL.Field_Generator_HV; break;
				case  4:			aRecipe[i] = IL.Field_Generator_EV; break;
				case  5:			aRecipe[i] = IL.Field_Generator_IV; break;
				case  6:			aRecipe[i] = IL.Field_Generator_LuV; break;
				case  7:			aRecipe[i] = IL.Field_Generator_ZPM; break;
				default:			aRecipe[i] = IL.Field_Generator_UV; break;
				}continue;}
				
				if (aRecipe[i] instanceof X) throw new IllegalArgumentException("MISSING TIER MAPPING FOR: " + aRecipe[i] + " AT TIER " + mTier);
			}
			
			if (!GT_ModHandler.addCraftingRecipe(getStackForm(1), RecipeBits.DISMANTLEABLE | RecipeBits.BUFFERED | RecipeBits.NOT_REMOVABLE | RecipeBits.REVERSIBLE, aRecipe)) {
				throw new IllegalArgumentException("INVALID CRAFTING RECIPE FOR: " + getStackForm(1).getDisplayName());
			}
		}
	}
	
	public GT_MetaTileEntity_BasicMachine_GT_Recipe(String aName, int aTier, String aDescription, RecipeMap aRecipes, int aInputSlots, int aOutputSlots, int aTankCapacity, int aAmperage, int aGUIParameterA, int aGUIParameterB, ITexture[][][] aTextures, String aGUIName, String aNEIName, String aSound, boolean aSharedTank, boolean aRequiresFluidForFiltering, int aSpecialEffect) {
		super(aName, aTier, aAmperage, aDescription, aTextures, aInputSlots, aOutputSlots, aGUIName, aNEIName);
		mSharedTank = aSharedTank;
		mTankCapacity = aTankCapacity;
		mSpecialEffect = aSpecialEffect;
		mRequiresFluidForFiltering = aRequiresFluidForFiltering;
		mRecipes = aRecipes;
		mSound = aSound;
		mGUIParameterA = (byte)aGUIParameterA;
		mGUIParameterB = (byte)aGUIParameterB;
	}
	
	@Override
	public IMetaTileEntity newMetaEntity(IGregTechTileEntity aTileEntity) {
		return new GT_MetaTileEntity_BasicMachine_GT_Recipe(mName, mTier, mDescription, mRecipes, mInputSlotCount, mOutputItems==null?0:mOutputItems.length, mTankCapacity, mAmperage, mGUIParameterA, mGUIParameterB, mTextures, mGUIName, mNEIName, mSound, mSharedTank, mRequiresFluidForFiltering, mSpecialEffect);
	}
	
	@Override
    public Object getServerGUI(int aID, InventoryPlayer aPlayerInventory, IGregTechTileEntity aBaseMetaTileEntity) {
		return new GT_Container_BasicMachine(aPlayerInventory, aBaseMetaTileEntity);
	}
	
	@Override
    public Object getClientGUI(int aID, InventoryPlayer aPlayerInventory, IGregTechTileEntity aBaseMetaTileEntity) {
		return new GT_GUIContainer_BasicMachine(aPlayerInventory, aBaseMetaTileEntity, getLocalName(), mGUIName, UT.Code.stringValid(mNEIName) ? mNEIName : getRecipeList() != null ? getRecipeList().mUnlocalizedName : "", mGUIParameterA, mGUIParameterB);
	}
	
	@Override
	public boolean allowPutStack(IGregTechTileEntity aBaseMetaTileEntity, int aIndex, byte aSide, ItemStack aStack) {
		if (!super.allowPutStack(aBaseMetaTileEntity, aIndex, aSide, aStack)) return false;
		if (mInventory[aIndex] != null) return true;
		switch (mInputSlotCount) {
		case  0: return false;
		case  1: return getFillableStack() == null ? !mRequiresFluidForFiltering && getRecipeList().containsInput(aStack) : null!=getRecipeList().findRecipe(getBaseMetaTileEntity(), mLastRecipe, true, V[mTier], new FluidStack[] {getFillableStack()}, getSpecialSlot(), new ItemStack[] {aStack});
		case  2: return (!mRequiresFluidForFiltering || getFillableStack() != null) && (((getInputAt(0)!=null&&getInputAt(1)!=null) || (getInputAt(0)==null&&getInputAt(1)==null?getRecipeList().containsInput(aStack):null!=getRecipeList().findRecipe(getBaseMetaTileEntity(), mLastRecipe, true, V[mTier], new FluidStack[] {getFillableStack()}, getSpecialSlot(), aIndex == getInputSlot() ? new ItemStack[] {aStack, getInputAt(1)} : new ItemStack[] {getInputAt(0), aStack}))));
		default: return getRecipeList().containsInput(aStack);
		}
	}
	
	@Override
	public void onPreTick(IGregTechTileEntity aBaseMetaTileEntity, long aTick) {
		super.onPreTick(aBaseMetaTileEntity, aTick);
		if (aBaseMetaTileEntity.isClientSide() && aBaseMetaTileEntity.isActive()) {
			switch (mSpecialEffect) {
			case 0:
				break;
			case 1:
				if (aBaseMetaTileEntity.getFrontFacing() != 1 && aBaseMetaTileEntity.getCoverIDAtSide((byte)1) == 0 && !aBaseMetaTileEntity.getOpacityAtSide((byte)1)) {
					Random tRandom = aBaseMetaTileEntity.getWorld().rand;
					aBaseMetaTileEntity.getWorld().spawnParticle("smoke", aBaseMetaTileEntity.getXCoord() + 0.8F -tRandom.nextFloat()*0.6F, aBaseMetaTileEntity.getYCoord() + 0.9F + tRandom.nextFloat()*0.2F, aBaseMetaTileEntity.getZCoord() + 0.8F -tRandom.nextFloat()*0.6F, 0.0D, 0.0D, 0.0D);
				}
				break;
			}
		}
	}
	
	@Override
	public RecipeMap getRecipeList() {
		return mRecipes;
	}
	
	@Override
	public int getCapacity() {
		return mTankCapacity;
	}
	
	@Override
	public void startSoundLoop(byte aIndex, double aX, double aY, double aZ) {
		super.startSoundLoop(aIndex, aX, aY, aZ);
		if (aIndex == 1 && UT.Code.stringValid(mSound)) UT.Sounds.play(mSound, 100, 1.0F, aX, aY, aZ);
	}
	
	@Override
	public void startProcess() {
		if (UT.Code.stringValid(mSound)) sendLoopStart((byte)1);
	}
	
	@Override
	public FluidStack getFillableStack() {
		return mSharedTank ? getDrainableStack() : super.getFillableStack();
	}
	
	@Override
	public FluidStack setFillableStack(FluidStack aFluid) {
		return mSharedTank ? setDrainableStack(aFluid) : super.setFillableStack(aFluid);
	}
	
	@Override
	protected boolean displaysOutputFluid() {
		return !mSharedTank;
	}
}